/*
 * File:    Main.java
 * Package: 
 * Project: Lekce03
 * 
 * Author : David Martinek
 * Address: Department of Intelligent Systems
 *          Faculty of Information Technology
 *          Brno University of Technology
 *          Bozetechova 2, 
 *          612 66 Brno, 
 *          Czech Republic
 * E-mail : martinek@fit.vutbr.cz
 * 
 * Created on 8.3.2005
 * (c) 2005, David Martinek
 * 
 * This project is provided under conditions of GNU General Public Licence.
 * The full text of GNU GPL in on internet: http://www.gnu.org/licenses/gpl.html
 * 
 * $Id$
 */

/**
 * Ukzka prce s metodami a promnnmi.
 *
 * @author David Martinek
 */
public class Main
{
  /** 
   * lensk promnn instance - jmno instance. Kad instance uchovv
   * vlastn hodnotu tto promnn.
   */
  String name;
  
  /**
   * lensk promnn tdy - potadlo instanc. Existuje jen jedna pro 
   * vechny instance. Inicializace se provede pouze jednou.
   * 
   * V tomto ppad je promnn privtn. To znamen, e nen viditeln
   * vn tdy a tud ji nikdo ciz neme pokodit. Pstup k takov
   * promnn je mon zajistit pomoc metod (zde pomoc getCount()). 
   * 
   * Vechny nelokln promnn jsou inicializovny automaticky na 0, 0.0,
   * false, '\u0000', nebo null. Inicializaci na jinou hodnotu lze provst
   * zde nebo v konstruktoru. U promnn tdy radji zde!
   */
  private static int count; 
  
  /**
   * Konstruktor. Vytvo novou instanci s implicitnm nastavenm.
   */
  public Main()
  {
    this("Implicitn");
    System.out.println("Konstruktor Main()");
  }
  
  /**
   * Peten konstruktor. Tmto je mon vytvoit instanci s uivatelskm
   * nastavenm.
   * @param name Jmno instance zadvan uivatelem.
   */
  public Main(String name)
  {
    this.name = name;
    count++; // zven tae instanc
    System.out.println("Konstruktor Main("+ name +")");
  }
  
  /**
   * Veejn metoda bez parametr.
   */
  public void tlac()
  {
    System.out.print(this.name);
    System.out.println(": Tlam z tlac()");
  }
  
  /**
   * Peten metoda. Od pvodn se li potem a typem parametr.
   * @param text Text, kter se vytiskne na standardn vstup.
   */
  public void tlac(String text)
  {
    System.out.print(this.name);
    System.out.print(": Tlam z tlac(String): ");
    System.out.println(text);
  }

  
  /**
   * Veejn statick metoda - metoda tdy. Pro jej vyvoln nen poteba
   * mt vytvoenou instanci, sta pout jmno tdy: Main.getCount(); 
   * 
   * Metody tdy, resp. statick metody mohou volat pouze jin statick
   * metody a mohou pouvat pouze statick datov poloky (poloky tdy).
   * 
   * Metody tdy rovn nemohou pouvat klov slovo this.
   * 
   * @return Vrac poet vytvoench instanc.
   */
  public static int getCount()
  {
    // this.tlac(); // Dvojit chyba.
    return count;
  }

  /**
   * Startovn bod programu.
   * @param args Argumenty pkazovho dku.
   */
  public static void main(String[] args)
  {
    System.out.println("Poet instanc: " + Main.getCount());
    
    Main test1 = new Main();         // jsme ve statick metod, proto
    Main test2 = new Main("Test2");  // je poteba vyrobit instance
    
    System.out.println("Poet instanc: " + Main.getCount());
    
    test1.tlac();
    test2.tlac("Vytlacil jsem tkhle dlouh text.");
    
    // Zde s koncem bloku, ve kterm byly vytvoeny, instance automaticky 
    // zaniknou. Nen poteba z pamti nco uvolovat run (ani to nejde). 
  }
}

// end of file Main.java
